<?xml version="1.0"?> 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- A *very perverse* xsl program that produces a shell script 
  containing a call to xsl foreach HelpPage tag to generate
  help pages.
  -->

  <xsl:output method="text"/>
  <xsl:param name="file"/>
  <xsl:param name="xsl"/>
  <xsl:param name="directory"/>
  <xsl:param name="src"/>
  <xsl:param name="xsl-compiler"/>

  <xsl:template match="/">
    <xsl:apply-templates />
  </xsl:template>
  
  
  <xsl:template match="text()"/>

  <!-- Process HelpPages (these ones are not taken into account for  -->
  <!-- the virtual machine, i.e. do not take part in the navigation) -->
  <!-- These ones are generated in html and not in php               -->
  <xsl:template match="HelpPage">

  <xsl:choose>

  <!-- libxslt case -->
  <xsl:when test="$xsl-compiler='xsltproc'">

<xsl:value-of select="$xsl-compiler"/>  --param helppage "'<xsl:value-of select="@name"/>'" --param src "'<xsl:value-of select="$src"/>'" <xsl:value-of select="$xsl"/> <xsl:text> </xsl:text> <xsl:value-of select="$file"/> > <xsl:value-of select="$directory"/>/<xsl:value-of select="@name"/>.html 

  </xsl:when>

  <!-- xalan case -->
  <xsl:otherwise>

<xsl:value-of select="$xsl-compiler"/> -IN <xsl:value-of select="$file"/> -XSL <xsl:value-of select="$xsl"/> -OUT <xsl:value-of select="$directory"/>/<xsl:value-of select="@name"/>.html -PARAM helppage "'<xsl:value-of select="@name"/>'" -PARAM src "'<xsl:value-of select="$src"/>'" 

  </xsl:otherwise>

  </xsl:choose>

  </xsl:template>


</xsl:stylesheet>

<!-- $Id: doc_script_maker.xsl,v 1.3 2002/02/22 17:19:42 philippe Exp $ -->
