
package com.mandrakesoft.wat;
import org.w3c.dom.Document;

/** 
 * Compiler front-end interface */
public interface Generator {

  /**
   * Called during the Compiler process, generate the code for
   * the (DOM) document contained in the parameter.
   * The document is a valid wat file */
  public void generateCode(Document doc);
}
