<?track_vars?>
<?php
/* Copyright (C) 2000,2001 Mandrakesoft                                  */
/* Authors :                                                             */
/* Enzo Maggi <emaggi@mandrakesoft.com>                                  */
/* Renaud Chaillat <rchaillat@mandrakesoft.com>                          */
/*                                                                       */
/* $Id: engine.php,v 1.2 2002/12/04 13:04:19 philippe Exp $             */

/*
 Copyright (C) 2002 MandrakeSoft SA
 
 This program may be distributed and/or
 modified under the terms of the GNU General Public
 License version 2 as published by the Free Software Foundation
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 Licensees holding valid MandrakeSecurity MNF Commercial License may use this
 file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
 provided with the Software.
 
 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/ 


/* The runtime engine for a naat interpreter.                            */
/* The state - PC, accumulator, stack - is saved into server-side files. */


// OLD (now in index.php) try to disable the browser cache
/*
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
header ("Pragma: no-cache");                          // HTTP/1.0
*/

//try to disable the browser cache
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
header ("Last-Modified: " .$date ." GMT"); // always modified
header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
header ("Pragma: no-cache");                          // HTTP/1.0


if (!$md5) { $md5=$mdk_sessid; }

require_once ("/var/www-naat/html/php/path.php");

//require_once("php_libs/path.php");
//include("interpreter/php_libs/naatlib.inc.php");
require_once("interpreter/php_libs/functions.php");
require_once("interpreter/php_libs/interpreter.php");

global $stack_file;
global $history_filename;

//unique id
//print $mdk_sessid."\n";

load_state();
  

if (!$cmd) { $cmd = ""; }
// Handle commands submitted via post: cmd = (Previous, Next, Cancel, Apply)
// 'Submit buttons' case
if ($HTTP_POST_VARS["cmd"] != "") {
  $cmd = $HTTP_POST_VARS["cmd"];
}
// 'Image-submit' case
// Here we must check exhaustively each command-name we know
// _x (and _y) is automatically appended by php, but we don't 
// care about the coordinates values.
// TODO: Konqueror does not handle this case in a standard way...
else {
  if ($HTTP_POST_VARS["Previous_x"] != "") { $cmd = "Previous"; }
  if ($HTTP_POST_VARS["Next_x"]     != "") { $cmd = "Next";     }
  if ($HTTP_POST_VARS["Cancel_x"]   != "") { $cmd = "Cancel";   }
  if ($HTTP_POST_VARS["Apply_x"]    != "") { $cmd = "Apply";    }
  // Handle the Konqueror way of posting these vars
  if ($HTTP_POST_VARS["Previous"] != "") { $cmd = "Previous"; }
  if ($HTTP_POST_VARS["Next"]     != "") { $cmd = "Next";     }
  if ($HTTP_POST_VARS["Cancel"]   != "") { $cmd = "Cancel";   }
  if ($HTTP_POST_VARS["Apply"]    != "") { $cmd = "Apply";    }
}


switch ($cmd) {
       
 case "Previous":

   if ( history_pop()) $current = $ACC;
   if ( history_pop()) $previous = $ACC;
       
   // Update the program counter to "SHOW" the appropriate page
   // (this will perform a history_push and increment CT)
   if ($previous)
     $PC = $previous;
   else if ($current)
     $PC = $current;
       
   break;

 case "Cancel":
   // Reinit the virtual machine and abort the backend transaction
   vm_reset();
   unset($a);
   exec("config-wrapper.pl ". $md5 ." -a",&$a,&$b);	
   delete_file($stack_file);
   delete_file($history_filename);
   $DEBUG = 0;
	
   /* goto to general index */
   // global $where;

   // if ($where)  { $where_str = "?where=".$where; }
   header("Location: index.php");
   return;

 case "Apply":
   // Commit the backend transaction
   // TODO: if another commit has occured during the transaction, 
   // go to an error page to ask whether the user wants to force 
   // the commit or not.
   unset($a);
   exec("config-wrapper.pl ". $md5 ." -c",&$a,&$b);	
   delete_file($stack_file);
   delete_file($history_filename);
       
   break;

 case "Next":
   break;

 case "go":
   $DEBUG=0;
 break;

 case "end":
   delete_file($stack_file);
   delete_file($history_filename);
   break;

 default:
   break;
}


// Use a configurable filename
if ($HTTP_POST_VARS["UploadedFilename"] != "") { 
  $UploadedFilename = $HTTP_POST_VARS["UploadedFilename"];    
} else {
  $UploadedFilename = "/var/lib/naat/UploadedConfiguration";
}

// UpdatedFile is the filename handler in the html input
if (is_uploaded_file($UpdatedFile)) 
{
  move_uploaded_file($UpdatedFile,$UploadedFilename);
} 
else 
{
  
}



// the "start" command does not come into HTTP_POST_VARS, but usually in the address

if ($cmd == "start")
{
  delete_file($stack_file);
  delete_file($history_filename);
  load_state();
  // Init the virtual machine
  vm_reset();
  // Init the backend transaction
  unset($a);
  exec("config-wrapper.pl ". $md5 ." -i",&$a,&$b);	
  $DEBUG = 0;
}

// Call the backend for the values posted by the user in the input fields
// First parse all values posted to create the command string 
// for the backend (e.g. "-s var1 value1.a value1.b -s var2 value2.a ...")
// Then execute the backend call to set all values at once.
$command_string="";
if (!empty($HTTP_POST_VARS)) {
  reset($HTTP_POST_VARS);

  // Parse all posted values
  while (list($var, $value) = each($HTTP_POST_VARS)) {
    // Handle lists of values (from checkbox lists for instance)
    if (is_array($value)) {
      $string_list = stringify_array($value);
      unset($value);
      $value = $string_list;
    }	   
    // We could remove unneeded vars (frontend_*, Next, Previous, ..., but doing the test 
    // each time here might not be more efficient than leaving the backend ignore them...)
    $command_string .= " -s ".$var." \"".$value."\" ";
  }

  // Execute the backend call to set the values in the current transaction
  $string = "config-wrapper.pl ". $md5 .$command_string;
  unset($a);
  exec("$string", &$a, &$b);
}

if ($DEBUG)
{
  include ("debug.php");
    
  html_header();

  debug_step();

  html_footer();
}
else  
_next();
	
save_state();

?>
