<?php

// V 0.07

/* TODO

	* add more widgets (lists, big textfields, labels among others)
	* manage more steps
	* change some values according to the step (ex : buttons)
	* fun : print some king of signature (ex : "<!-- Made by l33T f0rm gener4tor V 0.06 -->")

	* classes to add :
		- class "layout" to display the form nicely formatted
		- class "datacheck" to check the integrity of the data (ex : ensure that 2 fields are identical, that 1 field reuired by another is filled etc)

*/

define ('DEFAULTMAXSIZE', '50');

class widget {

	function check_maxsize() {
		if (strlen($input) > $this->maxsize) {
			 return false;
		} else { 
			return true;
		}
	}
	
	function check_nastychars() {
		
	}

	function check() {
		if(!$this->maxsize) $this->maxsize = DEFAULTMAXSIZE;
		if(!$this->type) $this->type = 'string';
		
		/* Available types : 
			label -> no check
			string 
			email
			URL
			
		*/
		
		switch ($this->type) {
			case 'string':
				// check size
				if (!$this->check_maxsize()) {
					return false;
				} else return true;
				
			break;
			case 'email':
				// check size
			break;
			case 'URL':
				// check size
			break;
			case 'date':
				// check size
			break;
			case 'label':
			break;
			default:
				return false;
			break;
		}
	}
}

class form {

	var $step;
	var $tabstep;

	function form($step='') {
		$this->tabstep = array('init','preview','preedit','insert','view','postedit','end');
		$this->step = $step;
	}

	function give_next($step='') {	// returns nex step
		if($step) {
			$st = $step;
		} else if ($this->step) {
			$st = $this->step;
		} else return false;
		
		$id = array_search($st, $this->tabstep);
		if(($id == 'FALSE') && ($id != 0)) return false;

		return $this->tabstep[$id+1];
	}
	
	function add($widget) {	// add a widget
	
		//var_dump($widget);
	
		$this->widgets[] = $widget;
		return true;
	}
	
	function make() {	// "makes" all the widgets : generates the form
	
		if(!$this->step) $this->step = 'init';
	
		/*
		case $step in
			1: format & print
			2: check & format & print
			3: check & format & print (editable)
			4: check & insert & format & print
			5: format & print
			
		*/
	
		foreach ($this->widgets as $wid) {
			switch ($this->step) {
				case 'init':		// first step : print blank form
					$wid->format();
					print ('	'.$wid->html."<br>\n");
					$step = 'preview';
					break;
				case 'preview':		// second step : preview data
					break;
				case 'preedit':		// third step : edit data not inserted
					break;
				case 'insert':		// fourth step : insert data
					break;
				case 'view':		// fith step : view inserted data
					break;
				case 'postedit':	// sixth step : edit inserted data
					break;
				default:
					break;
			}
		}
	}
}

class field extends widget {	/*   Single line textfield  or password */
	var $variable;		// variable name
	var $value;		// value (should not be needed)
	var $clear;		// 1 if text, 0 if password
	var $size;		// size of the field
	var $maxsize;		// maxsize
	var $initval;		// initial value
	var $type;		// type of data : string, dangerous, email, url, IP...
	var $db_field;		// database field
	var $dbp;		// database handler
	
	function field($variable, $value='', $clear='1', $size='15', $maxsize='20', $initval='', $type='string', $db_field='', $dbp='', $classform) {
	
		if(!$variable || !$classform) return false;
	
		$this->variable = $variable;
		$this->value = $value;
		$this->clear = $clear;
		$this->size = $size;
		$this->maxsize = $maxsize;
		$this->initval = $initval;
		$this->type = $type;
		$this->db_field = $db_field;
		$this->dbp = $dbp;
	
		$classform->add($this);		// registers itself. how smart ! :o)
	
		return true;
	}
	
	function format()  {	// format the field
		if($this->variable) $vvariable = 'name="'.$this->variable.'"';
		if($this->initval) $vinitval = 'value="'.$this->initval.'"';
		if($this->size) $vsize= 'size="'.$this->size.'"';
		if($this->maxsize) $vmaxsize = 'maxlength="'.$this->maxsize.'"';
		if($this->clear == '0')  {
			$fieldtype = 'password';
		} else { $fieldtype = 'text'; };
	
	
		$this->html = '<input type="'.$fieldtype.'" '.$vvariable.' '.$vinitval.' '.$vsize.' '.$vmaxsize.'>';
		
		return true;
	}
}

class longfield extends widget {	/* Long text field */
/*
<textarea name=address cols=40 rows=4 wrap=virtual>
Your Name Here
  1234 My Street
  Anytown, State Zipcode
</textarea>
*/

	var $variable;		// variable name
	var $value;		// value
	var $width;		// width
	var $height;		// height
	var $maxsize;		// Max size of the data
	var $initval;		// initial value
	var $type;		// type of data : string, dangerous, email, url, IP...
	var $db_field;		// database field
	var $dbp;		// database handler
	
	function longfield($variable, $value='', $width='15', $height='15', $maxsize='500', $initval='', $type='string', $db_field='', $dbp='', $classform) {
	
		if(!$variable || !$classform) return false;
	
		$this->variable = $variable;
		$this->value = $value;
		$this->width = $width;
		$this->height = $height;
		$this->maxsize = $maxsize;
		$this->initval = $initval;
		$this->type = $type;
		$this->db_field = $db_field;
		$this->dbp = $dbp;
	
		$classform->add($this);		// registers itself. how smart ! :o)
	
		return true;
	}
	
	function format()  {	// format the field
		if($this->variable) $vvariable = 'name="'.$this->variable.'"';
		if($this->width) $cols= 'cols="'.$this->width.'"';
		if($this->height) $rows= 'rows="'.$this->height.'"';

		$this->html = '<textarea name='.$this->variable.' '.$cols.' '.$rows.' wrap="virtual">'.$this->initval.'</textarea>';
	
		return true;
	}


}

class checkboxes {	/* group of checkboxes (to set up ONE array of value) */
/*
	$choices = array (
		array('money', '0'),
		array('honey', '0'),
		array('howee', '1')
	);
	$tastes = new checkboxes('tastes',$choices,'20','string','','');
*/
	var $variable;		// array name
	var $value;		// values (array [value] [checked])
	var $maxsize;		// maxsize
	var $type;		// type of data : string, dangerous, email, url, IP...
	var $db_field;		// database field
	var $dbp;		// database handler
	
	function checkboxes($variable, $value, $maxsize='20', $type='string', $db_field, $dbp, $classform) {
		if(!$variable || !$value || !$classform) return false ;
		
		$this->variable = $variable;
		$this->value = $value;
		$this->maxsize = $maxsize;
		$this->type = $type;
		$this->db_field = $db_field;
		$this->dbp = $dbp;
				
		foreach ($this->value as $vals) {
			$this->checks[] = new checkbox($this->variable,$vals[0],$vals[1],$this->maxsize,$this->type,$this->db_field,$this->dbp);
		}
		
		foreach ($this->checks as $obj) {
			$classform->add($obj);
		}
			
		return true;
	}
}


class checkbox extends widget {	/* checkbox */ //    <input type=checkbox name=pets value="bird">

	var $variable;		// variable name
	var $value;		// value
	var $checked;		// checked or not ?
	var $maxsize;		// maxsize
	var $type;		// type of data : string, dangerous, email, url, IP...
	var $db_field;		// database field
	var $dbp;		// database handler
	
	function checkbox($variable, $value, $checked='0', $maxsize='20', $type='string', $db_field, $dbp) {
		if(!$variable || !$value) return false ;
		
		$this->variable = $variable;
		$this->value = $value;
		$this->checked = $checked;
		$this->maxsize = $maxsize;
		$this->type = $type;
		$this->db_field = $db_field;
		$this->dbp = $dbp;
			
		return true;
	}
	
	function format() {
		if ($this->checked) $vchecked = 'checked';
		$this->html =  '<input type="checkbox" name="'.$this->variable.'" value="'.$this->value.'" '.$vchecked.'>';
		
		return true;
	}
}

class singlelist extends widget {		/* single list */

		/*
  <select name=pets size=3 multiple>
    <option>Dog
    <option>Cat
    <option>Bird
    <option>Fish
  </select>
		*/

	var $variable;		// value name
	var $value;		// values (array [value] [label] [selected])
	var $single;		// can select multiple values ? (hint : no)
	var $height;		// number of visible rows
	var $maxsize;		// maxsize
	var $type;		// type of data : string, dangerous, email, url, IP...
	var $db_field;		// database field
	var $dbp;		// database handler
	
	function singlelist($variable, $value, $single='1', $height='1', $maxsize='20', $type='string', $db_field, $dbp, $classform) {
		if(!$variable || !$value || !$classform) return false ;
		
		$this->variable = $variable;
		$this->value = $value;
		$this->single = $single;
		$this->height = $height;
		$this->maxsize = $maxsize;
		$this->type = $type;
		$this->db_field = $db_field;
		$this->dbp = $dbp;
			
		$classform->add($this);		// registers itself. how smart ! :o)	
			
		return true;
	}
	
	function format() {
		
		$options = "\n";
		foreach ($this->value as $vals) {
			if ($vals[2] == '1') {
				$sel = 'selected';
			} else {
				$sel = '';
			}
		
			$options .= '<option value="'.$vals[0].'" '.$sel.'>'.$vals[1].'</option>'."\n";
		}
	
		$this->html = '<select name="'.$this->variable.'" size="'.$this->height.'">'.$options.'</select>';
		
		return true;
	}
	

}

class button extends widget {		/* Button (submit, reset...)  */
	var $toa;		// type of action ("submit", "reset")
	var $label;		// button label
	var $action;		// action (optionnal, "action" by default)
	
	function button($toa='submit', $label='submit', $action='', $classform) {
		if (!$classform) return false;
	
		$this->toa = $toa;
		$this->label = $label;
		$this->action = $action;
		
		$classform->add($this);		// registers itself. how smart ! :o)
		
		return true;
	}
	
	function format() {
		if($this->toa) $vtoa = 'type="'.$this->toa.'"';
		if($this->label) $vlabel = 'value="'.$this->label.'"';
		if($this->action) $vaction = 'name="'.$this->action.'"';
		
		$this->html = '<input '.$vtoa.' '.$vlabel.' '.$vaction.'>';
		
		return true;
	}
}

class hidden extends widget { /*   Hidden fields  */

	var $name;		// name
	var $value;		// value
	var $db_field;		// database field
	var $dbp;		// database handler
	
	function hidden($name, $value, $db_field='', $dbp='', $classform) {
		if (!$name || !$value || !$classform) return false;
		
		$this->name = $name;
		$this->value = $value;
		$this->db_field = $db_field;
		$this->dbp = $dbp;
		
		$classform->add($this);		// registers itself. how smart ! :o)
		
		return true;
	}
	
	function format() {
		$this->html = '<input type="hidden" name="'.$this->name.'" value="'.$this->value.'">';
		return true;
	}
}

class label extends widget {
	
	var $value;		// the label
	
	function label($value, $classform) {
	
		if(!$value || !$classform) return false;
		
		$this->value = $value;
		$this->maxsize = '1000';	// "almost" no size limit
		$this->type = 'label';		// label -> no check
		
		$classform->add($this);		// registers itself. how smart ! :o)
		
		return true;
	}
	
	function format() {
		$this->html = $this->value;
		
		return true;
	}
}

?><html>
<head>
	<title>Form test page</title>
</head>

<body>
	Hello, world !
	<form method="post">
<?php

	$checkchoices = array (		// checkbox choices
		array('money', '0'),
		array('honey', '1'),
		array('howee', '0')
	);

	$listchoices = array (
		array('1','Paris','1'),
		array('2','Limoges','0'),
		array('3','Londres','0'),
		array('4','Nieul','0'),
	);

	if(!$step) $step = 'init';	// default step : 'init'
	$myform = new form($step);	// form class instantiation
	$nextstep = $myform->give_next($step);	// gives nexstep
	
	$lfirtsname = new label('Prnom :', &$myform);
	$firstname = new field('firstname','','1','10','25','Amaury','string','','',&$myform); 
	$llastname = new label('Nom :', &$myform);
	$lastname = new field('lastname','','1','10','25','Amblard-Ladurantie','string','','',&$myform);
	$password = new field('password','','0','10','25','tralala','string','','',&$myform);
	$tastes = new checkboxes('tastes[]',$checkchoices,'20','string','','',&$myform);
	$comments = new longfield('comments','','45','10','400','Bla bla bla this is a comment','string','','',&$myform);
	$city = new singlelist('city',$listchoices,'1','1','30','string','','',&$myform);
	$submit = new button('submit','Submit','',&$myform);
	$reset = new button('reset','Reset','',&$myform);
	$hstep = new hidden('step',$nextstep,'','',&$myform);
		
	$myform->make();
?>
	</form>
</body>
</html>
