<?xml version="1.0"?> 
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <!-- define here a parameter to be passed from outside. If mode = 1, all the hierarchy of menus is shown. -->
  <!-- otherwise, just the top level tasks -->

  <xsl:param name="mode"/>

  <xsl:template match="/">
  <html>
    <body>
    <ol>
    <xsl:apply-templates mode="menu"/>
	<hr/>
    <xsl:apply-templates mode="content"/>
    </ol>
    </body>
  </html>
  </xsl:template>
  
  <xsl:template match="Task" mode="menu">
    <li>
    <xsl:choose>
        <xsl:when test="$mode=1">
	    <xsl:choose>
	      <xsl:when test="count(child::*)=0">
	        <xsl:value-of select="@name"/>
	      </xsl:when>
	      <xsl:otherwise>
	      	    <a href="un qualche ref">
		    <b>
		    <xsl:value-of select="@name"/>
		    </b>
		    </a>
	      </xsl:otherwise>
	    </xsl:choose>
	        <ol>
		    <xsl:apply-templates mode="menu"/>
	        </ol>

	</xsl:when>
	<xsl:when test="$mode=0">
	    <a href="altrove">
	    <xsl:value-of select="@name"/>
	    </a>
	</xsl:when>
    </xsl:choose>
    </li>
  </xsl:template>

  <xsl:template match="Leaf" mode="menu">
    <li>
      <a href="un qualche href">
      <xsl:value-of select="@name"/>
      </a>
    </li>
  </xsl:template>


  <xsl:template match="Leaf" mode="content">
    <p>
    <h1> Hu-hu, there is a Leaf named &quot;
	<xsl:value-of select="@name"/> &quot;
    </h1>
	<br> I should represent it... hu hu...</br>
    </p>
  </xsl:template>

</xsl:stylesheet>
