
package com.mandrakesoft.wat;

  /**
   * An utility class for the informations needed during the compilation */
public class CompilerInfo
{
  public CompilerInfo()
  {
    lineNo = 0;
    next = 0;
  }
  
  public CompilerInfo(int line)
  {
    lineNo = line;
  }
  
  public CompilerInfo(int line, int next)
  {
    lineNo = line;
    this.next = next;
  }
  
  public int getLineNo()
  {
    return lineNo;
  }
  
  public int getNext() 
  {
    return next;
  }
  
  public void setLineNo(int line)
  {
    lineNo = line;
  }
  
  public void setNext(int nxt)
  {
    next = nxt;
  }
  
  int lineNo;
  int next;
  final static int NONE=-1;
}

