<?php

/* The runtime engine for a wat interpreter. */
/* The program counter is stored in a file for now. */

  $file = fopen("test.txt", 'r'); 
  $pcfd = fopen("PC", 'r+');
  $PC=0;  //program counter
  
  fscanf($pcfd, "%d", &$PC);
  gotoLine($PC, $file);

  // next one is THE line to interpret
  $lineNo = next_token($file);
  $instruction = next_token($file);

  print "DEBUG: line = " . $lineNo . " instruction = " . $instruction . "\n";
  while ($instruction == "IF") {

    exec( next_token($file), &$array, &$status);
    if ($status == next_token($file)) 
      $PC = next_token($file);
    else {
      next_token($file);
      $PC=next_token($file);
    }

    gotoLine($PC, $file); 
    $lineNo = next_token($file);
    $instruction = next_token($file);
  }

// executing the SHOW istruction:
{  
  print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2 Final//EN\">\n";
  print "<HTML>\n"; 
  print "<HEAD>\n";
  print "<TITLE></TITLE>\n";
  print "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; url=" . next_token($file) . ".html" . "\">\n";
  print "</HEAD>\n";
  print "<BODY>\n";
  print "</BODY>\n";
  print "</HTML>\n";
  $PC = next_token($file);
}

// updating the PC on file:
  print "-----> new PC: " . $PC . "\n";
  fseek($pcfd, 0);
  fwrite($pcfd, $PC) ;


  fclose($file);
  fclose($pcfd);
  

  function gotoLine($progCounter, &$file)
  {
    
    fseek($file, 0);
    for ($i = 0; $i < $progCounter - 1 ; $i++)
      fgets($file, 4096) . "\n";
  }

  function next_token(&$file)
    {
      $c = "";
      $d = "";
      
      $d = fgetc($file);
      while( ! feof($file) && $d != "\t" && $d != "\n") {
	$c .= $d;
	$d = fgetc($file);
      }

      return $c;
    }

?>
