<?php_post_vars?>
<?php

/* Copyright (C) 2000,2001 Mandrakesoft                                  */
/* Authors :                                                             */
/* Renaud Chaillat <rchaillat@mandrakesoft.com>                          */
/*                                                                       */
/* $Id: utils.php,v 1.3 2002/12/04 13:04:19 philippe Exp $ */


/*
 Copyright (C) 2002 MandrakeSoft SA
 
 This program may be distributed and/or
 modified under the terms of the GNU General Public
 License version 2 as published by the Free Software Foundation
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 Licensees holding valid MandrakeSecurity MNF Commercial License may use this
 file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
 provided with the Software.
 
 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/ 

/**
 utilies for handling the data of a naat program */

  /* Return the number of the action selected by the user 
   *
   */
  function frontend_get_action()
  {
	global $HTTP_POST_VARS;
	
	$i = 1;
	// POST method: Handle 'submit buttons' and 'submit images'
	while ( ($HTTP_POST_VARS["action$i"] == "")       &&
		($HTTP_POST_VARS["action".$i."_x"] == "") &&
		$i < 20 ) { // 20 actions max on a page
		$i++;
	}
	// Handle action passed by GET method
	if ($i == 20) {
		$i = 0;
		do {
			$i++;
			$varname = "action$i";
			global $$varname;
			if ($$varname != "") break;
		} while ($i < 20); // 20 actions max on a page
		if ($i == 20) $i = 0;
	}
	return $i;
  }


  /* Returns 1 if the current action is the list of actions passed as argument 
   * Returns 0 if the action was not in the list
   */
  function frontend_test_action($args_array)
  {
    $action_number = frontend_get_action ();
    
    $test = 0;
    for ($action_index=0; $action_index<sizeof ($args_array); $action_index++) {
      if ($args_array[$action_index] == $action_number) {
	$test=1;
      }
    }

    return $test;

  }



  /* Perform a comparaison between two "frontend" variables 
   *
   * These variables are temporary : they may be explicit frontend 
   * variables (like frontend_param1), or variables just posted 
   * from a form (like HTTP_POST_VARS["InternetInterface"]).
   *
   * Arg: an array of arguments
   *      Arg[0] : var1 name to test
   *      Arg[1] : var2 name to compare
   */
  function frontend_compare($args_array)
  {
          // First get global parameters in case we need it
	  global $HTTP_POST_VARS;
	  for ($i=0; $i<20; $i++) {
	      $param_name = "frontend_param$i";
	      global $$param_name;
	  }

	  for ($i=0; $i<2; $i++) {
		$varname = "var$i";
		if ( preg_match("/^frontend_/",$args_array[$i]) ) {
			$$varname = $$args_array[$i]; 		
		} else {
	  		$$varname = $HTTP_POST_VARS["$args_array[$i]"];
		}
	  }

	  if ($var0 == $var1) {
	      return 1;
	  }
	  return 0;
  }

  /* Perform a test on a frontend variable 
   * (equivalent to the backend test config-test.pl)
   *
   * Used to perform tests on temporary frontend variables
   * (just posted from a form or set as a frontend_parameter),
   * and avoid unnecessary perl calls.
   *
   * Arg: an array of arguments
   *      Arg[0] : frontend var name to test
   *      Arg[1],... : values to test against
   * 
   * Return:
   * 0 if the frontend var has a value but is not equal to any given argument
   * 1, 2, ... or n if the value matches one of the given arguments
   * 255 if the variable is empty
   */
  function frontend_test($args_array)
  {
          // First get global parameters in case we need it
	  global $HTTP_POST_VARS;
	  for ($i=0; $i<20; $i++) {
	      $param_name = "frontend_param$i";
	      global $$param_name;
	  }

	  eval ("\$args_array[0] = \"$args_array[0]\";"); // In case it is an indirect variable name

	  // Test posted variables (be it a backend variable name or a frontend_param name)
	  $frontend_var = $HTTP_POST_VARS["$args_array[0]"];
	  
	  // If not posted, try global
	  if (! isset($frontend_var)) {
	    $frontend_var = ${$args_array[0]};
	  }

	  if ( $frontend_var == "" ) {
	    return 255;
	  }

	  $value        = $args_array[1];
	  eval ("\$value = \"$value\";"); // In case 'value' is a variable content (${frontend_param1} for example)

	  for ($index=0; $index < sizeof ($args_array) - 1; $index++) {
	    $value = $args_array[$index+1];
	    if ($frontend_var == $value) {
	      return $index+1;
	    }
	  }
	  return 0;
  }

/* function stringify_array
 *
 * Takes an array of strings in argument and returns
 * a comma-separated string.
 * Used mostly to handle post from multiple-selection lists
 * like checkbox lists.
 */
function stringify_array ($array)
{
        $string    = "";
        $separator = "";
        for ($item_index=0; $item_index < count($array); $item_index++) {
                $string .= $separator.$array[$item_index];
                $separator = ",";
        }

        return $string;
}


?>
