<?xml version="1.0"?>

<!-- Output: Group | wizard1
				   | wizard2

-->

<xsl:stylesheet version='1.0' xmlns:xsl='http://www.w3.org/1999/XSL/Transform'> 

  <xsl:param name="address"/>

   <xsl:output method="html" indent="yes"/>

   <xsl:template match="/"> 
<table width="168" border="0" cellspacing="0" cellpadding="0">
     <xsl:apply-templates select="root//*"/> 
</table>

   </xsl:template> 
 

   <!-- This template deals with the top-level groups -->
   <xsl:template match="root/*"> 
     <xsl:if test="not(descendant::*[name()=name(current())] | following::*[name()=name(current())])"> 
   <TR>
	<TD width="21">
		<img src="../images/zz_navbaroff.gif" width="21" height="34" /></TD>
	<TD class="main_menu"><xsl:value-of select="name()"/></TD>
   </TR> 
   	<TR>
	    <TD width="21" valign="top"></TD>

	   	<xsl:apply-templates select="." mode='list'/>

	</TR>
     </xsl:if> 
   </xsl:template> 
 
   <!-- This template deals with the items inside each group -->
   <xsl:template match="root/*" mode='list'>
	 <TD>
     <xsl:for-each select="//*[name()=name(current())]/*"> 
		<IMG src="../images/zz_subnavbar-dot.gif" width="9" height="6"/>
	   <A class="sub_menu" >
		   <xsl:choose>
			<xsl:when test="string-length(@href)>0">
	     		<xsl:attribute name="HREF"> 
				<xsl:value-of select="@href"/>
				</xsl:attribute>
		    </xsl:when>
			    <xsl:otherwise>
	     		<xsl:attribute name="HREF"> 
		 <xsl:value-of select="$address"/>?file=<xsl:value-of select="name()"/>/<xsl:value-of select="name()"/>.wvm&amp;cmd=start</xsl:attribute>
		     	</xsl:otherwise>
		   </xsl:choose>
		 <xsl:value-of select="@name"/>
		 </A>
	 <BR/>
   <!-- This template generate debug menu only for testing 
		 <br/>
		 <a class="sub_menu" >
		 <xsl:attribute name="href">
		 <xsl:value-of select="$address"/>?file=<xsl:value-of select="name()"/>/<xsl:value-of select="name()"/>.wvm&amp;DEBUG=1&amp;cmd=reset</xsl:attribute> (debug version)
		 </a>
		 -->

     </xsl:for-each> 
   </TD> 
   </xsl:template> 

</xsl:stylesheet>

<!-- $Id: hierarchy.xsl,v 1.1.1.1 2001/06/13 11:38:15 rchaillat Exp $ -->
